package es.uniovi.healthappv2;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Build;
import android.os.IBinder;
import android.util.Log;

import androidx.annotation.RequiresApi;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Date;

public class Alarm extends BroadcastReceiver
{
    Context contexto;

    @Override
    public void onReceive(Context context, Intent intent)
    {
        //Se envía un mensaje por broadcast que se recibe en LocalService para iniciar la medición
        Log.d("Alarm","onReceive()");

        Intent myIntent = new Intent("Medir");
        myIntent.putExtra("Mide", 1.0);
        LocalBroadcastManager.getInstance(context).sendBroadcast(myIntent);


    }

    public void setAlarm(Context context, long minutos)
    {
        Log.d("setAlarm()-Alarm","Inicio");

        contexto=context;
        AlarmManager am =( AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
        Intent i = new Intent(context, Alarm.class);
        PendingIntent pi = PendingIntent.getBroadcast(context, 0, i, 0);
        am.setRepeating(AlarmManager.RTC_WAKEUP, System.currentTimeMillis(), 1000 * 60 * minutos, pi);
    }

    public void cancelAlarm(Context context)
    {
        Log.d("setAlarm()-Alarm","Cancelada");
        Intent intent = new Intent(context, Alarm.class);
        PendingIntent sender = PendingIntent.getBroadcast(context, 0, intent, 0);
        AlarmManager alarmManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
        alarmManager.cancel(sender);
    }


}